Index: /trunk/src/sh_utils.c
===================================================================
--- /trunk/src/sh_utils.c	(revision 584)
+++ /trunk/src/sh_utils.c	(revision 1)
@@ -1607,160 +1283,11 @@
 
 static unsigned char sh_obscure_index[256];
-static int sh_obscure_no_check = S_FALSE;
-
-int sh_util_valid_utf8 (const unsigned char * str) 
-{
-  const int     sh_val_utf8_1 = 1;
-  const int     sh_val_utf8_2 = 2;
-  const int     sh_val_utf8_3 = 3;
-  const int     sh_val_utf8_4 = 4;
-
-  size_t        len = strlen((const char *)str);
-  size_t        l   = 0;
-  int           typ = 0;
-  unsigned char c     = '\0';
-  unsigned char c2[2] = { 0x00, 0x00 };
-  unsigned char c3[3] = { 0x00, 0x00, 0x00 };
-
-
-#define SH_VAL_UTF8_1 ((c != '\0') && ((c & 0x80) == 0x00))
-#define SH_VAL_UTF8_2 ((c != '\0') && ((c & 0xE0) == 0xC0)) /* 110x xxxx */
-#define SH_VAL_UTF8_3 ((c != '\0') && ((c & 0xF0) == 0xE0)) /* 1110 xxxx */
-#define SH_VAL_UTF8_4 ((c != '\0') && ((c & 0xF8) == 0xF0)) /* 1111 0xxx */
-#define SH_VAL_UTF8_N ((c != '\0') && ((c & 0xC0) == 0x80)) /* 10xx xxxx */
-#define SH_VAL_BAD    ((c == '"')  || (c == '\t') || (c == '\b') || \
-                       (c == '\f') || (c == '\n') || \
-                       (c == '\r') || (c == '\v') || iscntrl((int) c) || \
-                       (c != ' ' && !isgraph ((int) c)))
-   
-  while(l < len) 
-    {
-      c = str[l];
-
-      if      (SH_VAL_UTF8_1) 
-	{
-	  if (!(SH_VAL_BAD && (sh_obscure_index[c] != 1)))
-	    {
-	      typ = sh_val_utf8_1;
-	      ++l; continue;
-	    }
-	  else
-	    {
-	      return S_FALSE;
-	    }
-	} 
-      else if (SH_VAL_UTF8_2) 
-	{ 
-	  typ = sh_val_utf8_2;
-	  c2[0] = c;
-	  if ((c & 0x3e) != 0x00) /* !(overlong 2-byte seq.) */
-	    {
-	      ++l; 
-	      if (l != len) {
-		c = str[l];
-		if(SH_VAL_UTF8_N) {
-		  c2[1] = c;
-		  ++l; continue;
-		} 
-		else {
-		  return S_FALSE;
-		} 
-	      } 
-	      else {
-		return S_FALSE; 
-	      }
-	    }
-	  else
-	    {
-	      return S_FALSE; /* overlong 2-byte seq. */
-	    }
-	} 
-      else if (SH_VAL_UTF8_3) 
-	{
-	  typ = sh_val_utf8_3;
-	  c3[0] = c;
-	  ++l; if (l == len) return S_FALSE; c = str[l];
-	  if(!SH_VAL_UTF8_N) return S_FALSE;
-	  if (((str[l-1] & 0x1F) == 0x00) && ((c & 0x60) == 0x00))
-	    return S_FALSE; /* overlong 3-byte seq. */
-	  c3[1] = c;
-	  ++l; if (l == len) return S_FALSE; c = str[l];
-	  if(!SH_VAL_UTF8_N) return S_FALSE;
-	  c3[2] = c;
-	  ++l; continue;
-	} 
-      else if (SH_VAL_UTF8_4) 
-	{
-	  typ = sh_val_utf8_4;
-	  ++l; if (l == len) return S_FALSE; c = str[l];
-	  if(!SH_VAL_UTF8_N) return S_FALSE;
-	  if (((str[l-1] & 0x0F) == 0x00) && ((c & 0x70) == 0x00))
-	    return S_FALSE; /* overlong 4-byte seq. */
-	  ++l; if (l == len) return S_FALSE; c = str[l];
-	  if(!SH_VAL_UTF8_N) return S_FALSE;
-	  ++l; if (l == len) return S_FALSE; c = str[l];
-	  if(!SH_VAL_UTF8_N) return S_FALSE;
-	  ++l; continue;
-	}
-      return S_FALSE;
-    }
-
-  /* last character is invisible (space or else)
-   */
-  if (typ == sh_val_utf8_1)
-    { 
-      if (c != ' ')
-	return S_TRUE;
-      else
-	return S_FALSE;
-    }
-  else if (typ == sh_val_utf8_2)
-    {
-      if (c2[0] == 0xC2 && c2[1] == 0xA0) /* nbsp */
-	return S_FALSE;
-      else
-	return S_TRUE;
-    }
-  else if (typ == sh_val_utf8_3)
-    {
-      if (c3[0] == 0xE2) 
-	{
-	  if (c3[1] == 0x80 && c3[2] >= 0x80 && c3[2] <= 0x8F)
-	    return S_FALSE; /* various spaces, left-to-right, right-to-left */
-	  else if (c3[1] == 0x80 && (c3[2] == 0xA8 || c3[2] == 0xA9 || 
-				     c3[2] == 0xAD || c3[2] == 0xAF))
-	    return S_FALSE; /* line sep, para sep, zw word joiner, nnbsp */
-	  else if (c3[1] == 0x81 && (c3[2] == 0xA0 || c3[2] == 0xA1 || 
-				     c3[2] == 0x9F))
-	    return S_FALSE; /* word joiner, function app, math space */
-	  else
-	    return S_TRUE;
-	}
-      else if (c3[0] == 0xE3 && c3[1] == 0x80 && c3[2] == 0x80)
-	{
-	  return S_FALSE; /* ideographic space */
-	}
-      else if (c3[0] == 0xEF && c3[1] == 0xBB && c3[2] == 0xBF)
-	{
-	  return S_FALSE; /* zwnbsp */
-	}
-      else
-	{
-	  return S_TRUE;
-	}
-    }
-  else
-    {
-      return S_TRUE;
-    }
-}
-
-
-int sh_util_obscure_ok (const char * str)
+
+int sh_util_obscure_ok (char * str)
 {
   unsigned long   i;
-  char * endptr = NULL;
-
-  SL_ENTER(_("sh_util_obscure_ok"));
+  char * endptr = str;
+
+  SL_ENTER(_("sh_util_obscure_ex"));
 
   if (0 == sl_strncmp("all", str, 3))
@@ -1770,9 +1297,6 @@
 	  sh_obscure_index[i] = (unsigned char)1;
 	}
-      sh_obscure_no_check = S_TRUE;
-      SL_RETURN(0, _("sh_util_obscure_ok"));
-    }
-
-  sh_obscure_no_check = S_FALSE;
+      SL_RETURN(0, _("sh_util_obscure_ex"));
+    }
 
   for (i = 0; i < 255; ++i)
@@ -1780,13 +1304,4 @@
       sh_obscure_index[i] = (unsigned char)0;
     }
-
-  i = strtoul (str, &endptr, 0);
-  if (i > 255)
-    {
-      SL_RETURN(-1, _("sh_util_obscure_ok"));
-    }
-  sh_obscure_index[i] = (unsigned char)1;
-  if (*endptr == ',')
-    ++endptr;
 
   while (*endptr != '\0')
@@ -1795,5 +1310,5 @@
       if (i > 255)
 	{
-	  SL_RETURN(-1, _("sh_util_obscure_ok"));
+	  SL_RETURN(-1, _("sh_util_obscure_ex"));
 	}
       sh_obscure_index[i] = (unsigned char)1;
@@ -1801,26 +1316,12 @@
 	++endptr;
     }
-  SL_RETURN(0, _("sh_util_obscure_ok"));
-}
-
-static int sh_obscure_check_utf8 = S_FALSE;
-
-int sh_util_obscure_utf8 (const char * c)
-{
-  int i;
-  SL_ENTER(_("sh_util_obscure_utf8"));
-  i = sh_util_flagval(c, &(sh_obscure_check_utf8));
-  if (sh_obscure_check_utf8 == S_TRUE)
-    sh_obscure_no_check = S_FALSE;
-  SL_RETURN(i, _("sh_util_obscure_utf8"));
-}
-
-
-int sh_util_obscurename (ShErrLevel level, const char * name_orig, int flag)
-{
-  const unsigned char * name = (const unsigned char *) name_orig;
+  SL_RETURN(0, _("sh_util_obscure_ex"));
+}
+
+int sh_util_obscurename (ShErrLevel level, char * name_orig, int flag)
+{
+  char * name = name_orig;
   char * safe;
   unsigned int i;
-  size_t len = 0;
 
   SL_ENTER(_("sh_util_obscurename"));
@@ -1828,184 +1329,93 @@
   ASSERT_RET((name != NULL), _("name != NULL"), (0))
 
-  if (sh_obscure_no_check == S_FALSE)
-    {
-      if (sh_obscure_check_utf8 != S_TRUE)
-	{
-	  /* -- Check name. --
-	   */
-	  while (*name != '\0') 
+  /* -- Check name. --
+   */
+  while (*name != '\0') 
+    {
+      if ( (*name) == '"'  || (*name) == '\t' ||
+	   (*name) == '\b' || (*name) == '\f' || 
+	   (*name) == '\n' || (*name) == '\r' ||
+	   (*name) == '\v' || iscntrl((int) *name) || 
+	   ((*name) != ' ' && !isgraph ((int) *name)) ) 
+	{
+	  i = (unsigned char) *name;
+	  if (sh_obscure_index[i] != (unsigned char)1)
 	    {
-	      if ( (*name) >  0x7F || (*name) == '"'  || (*name) == '\t' ||
-		   (*name) == '\b' || (*name) == '\f' || 
-		   (*name) == '\n' || (*name) == '\r' ||
-		   (*name) == '\v' || iscntrl((int) *name) || 
-		   ((*name) != ' ' && !isgraph ((int) *name)) ) 
+	      if (flag == S_TRUE)
 		{
-		  i = (unsigned char) *name;
-		  if (sh_obscure_index[i] != (unsigned char)1)
-		    {
-		      goto err;
-		    }
+		  safe = sh_util_safe_name (name_orig);  
+		  sh_error_handle (level, FIL__, __LINE__, 0, MSG_FI_OBSC, 
+				   safe);
+		  SH_FREE(safe);
 		}
-	      name++; ++len;
+	      SL_RETURN((-1),_("sh_util_obscurename"));
 	    }
-
-	  /* Check for blank at end of name
-	   */
-	  if ((len > 0) && (name_orig[len-1] == ' '))
-	    {
-	      goto err;
-	    }
-	}
-      else
-	{
-	  if (S_FALSE == sh_util_valid_utf8(name))
-	    {
-	      goto err;
-	    }
-	  SL_RETURN((0),_("sh_util_obscurename"));
-	}
-    }
-      
+	}
+      name++;
+    }
+
   SL_RETURN((0),_("sh_util_obscurename"));
-
- err:
-  
-  if (flag == S_TRUE)
-    {
-      safe = sh_util_safe_name (name_orig);  
-      sh_error_handle (level, FIL__, __LINE__, 0, MSG_FI_OBSC, 
-		       safe);
-      SH_FREE(safe);
-    }
-  SL_RETURN((-1),_("sh_util_obscurename"));
-}
-
+}
 #endif
 
 /* returns freshly allocated memory, return value should be free'd
  */
-char * sh_util_dirname(const char * fullpath)
+char * sh_util_basename(char * fullpath)
 {
   char * retval;
-  size_t len;
-  char * tmp;
-
-  SL_ENTER(_("sh_util_dirname"));
+  size_t i;
+
+  SL_ENTER(_("sh_util_basename"));
 
   ASSERT_RET ((fullpath != NULL), _("fullpath != NULL"), (NULL))
-  ASSERT_RET ((*fullpath == '/'), _("*fullpath == '/'"), (NULL))
-
-  retval = sh_util_strdup(fullpath);
-
-  tmp    = retval;
-  while (*tmp == '/') ++tmp;
-
-  /* (1) only leading slashes -- return exact copy 
+
+  i = sl_strlen (fullpath);  /* fullpath[i] is terminating '\0' */
+
+  while (i > 0) {
+    --i;
+    if (fullpath[i] == '/') break;
+  }
+
+  /* -- Not a valid path. --
    */
-  if (*tmp == '\0')
-    {
-      SL_RETURN(retval, _("sh_util_dirname"));
-    }
-
-  /* (2) there are non-slash characters, so delete trailing slashes
-   */
-  len    = sl_strlen (retval);     /* retval[len] is terminating '\0' */
-
-  while (len > 1 && retval[len-1] == '/')    /* delete trailing slash */
-    {
-      retval[len-1] = '\0';
-      --len;
-    }
-
-  /* (3) now delete all non-slash characters up to the preceding slash
-   */
-  while (len > 1 && retval[len-1] != '/') {
-    retval[len-1] = '\0';
-    --len;
-  }
-
-  /* (4a) only leading slashes left, so return this
-   */
-  if (&(retval[len]) == tmp)
-    {
-      SL_RETURN(retval, _("sh_util_dirname"));
-    }
-
-  /* (4b) strip trailing slash(es) of parent directory
-   */
-  while (len > 1 && retval[len-1] == '/') {
-    retval[len-1] = '\0';
-    --len;
-  }
-  SL_RETURN(retval, _("sh_util_dirname"));
-
+  if ((fullpath[i] != '/') && (i == 0) ) 
+    SL_RETURN(NULL, _("sh_util_basename"));
+
+  retval = SH_ALLOC(i + 1);
+
+  (void) sl_strlcpy (retval, fullpath, i+1);
+
+  SL_RETURN(retval, _("sh_util_basename"));
 }
 
 /* returns freshly allocated memory, return value should be free'd
  */
-char * sh_util_basename(const char * fullpath)
-{
-  char       * retval = NULL;
-  const char * tmp;
-  char       * tmp2;
-  char       * c;
-  size_t       len;
-
-  SL_ENTER(_("sh_util_basename"));
+char * sh_util_filename(char * fullpath)
+{
+  char * retval;
+  char * c;
+  size_t i;
+
+  SL_ENTER(_("sh_util_filename"));
 
   ASSERT_RET ((fullpath != NULL), _("fullpath != NULL"), (NULL))
 
-  tmp = fullpath; while (*tmp == '/') ++tmp;
-  if (*tmp == '\0')
-    {
-      retval = sh_util_strdup(fullpath);
-    }
-  else
-    {
-      tmp2 = sh_util_strdup(tmp);
-      len  = sl_strlen (tmp2);
-
-      while (len > 1 && tmp2[len-1] == '/')
-	{
-	  tmp2[len-1] = '\0';
-	  --len;
-	}
-
-      if (tmp2) /* for llvm/clang analyzer */
-	{
-	  c = strrchr(tmp2, '/');
-	  if (c)
-	    {
-	      retval = sh_util_strdup(++c);
-	      SH_FREE(tmp2);
-	    }
-	  else
-	    {
-	      retval = tmp2;
-	    }
-	}
-    }
-
-  SL_RETURN(retval, _("sh_util_basename"));
-}
-
-#define SH_ESCAPE_SPACE      1
-#define SH_DONT_ESCAPE_SPACE 0    
-char * sh_util_safe_name_int (const char * name, int escape_space);
-
+  c = strrchr(fullpath, '/');
+  i = sl_strlen (c);
+  if (i <= 1) SL_RETURN(NULL, _("sh_util_filename")); /* ends in '/' */
+  ++c;
+  --i;
+
+  retval = SH_ALLOC(i + 1);
+
+  (void) sl_strlcpy (retval, c, i+1);
+
+  SL_RETURN(retval, _("sh_util_filename"));
+}
+
+    
+/* returns freshly allocated memory, return value should be free'd
+ */
 char * sh_util_safe_name (const char * name)
-{
-  return sh_util_safe_name_int (name, SH_ESCAPE_SPACE); 
-}
-
-char * sh_util_safe_name_keepspace (const char * name)
-{
-  return sh_util_safe_name_int (name, SH_DONT_ESCAPE_SPACE); 
-}
-
-/* returns freshly allocated memory, return value should be free'd
- */
-char * sh_util_safe_name_int (const char * name, int escape_space)
 {
   register int  i = 0;
@@ -2014,5 +1424,4 @@
   char          oct[32];
   char          format[16];
-  size_t        len;
 
   SL_ENTER(_("sh_util_safe_name"));
@@ -2031,32 +1440,13 @@
   */
 
-  len = sl_strlen(name);
-  p   = name;
-
 #ifdef SH_USE_XML
-  if (sl_ok_muls (6, len) && sl_ok_adds ((6*len), 2))
-    { retval = SH_ALLOC(6 * len + 2); }
-  else
-    {
-      /* return an allocated array
-       */
-      retval = SH_ALLOC(11);
-      (void) sl_strlcpy(retval, _("(overflow)"), 11);
-      SL_RETURN(retval, _("sh_util_safe_name"));
-    }
+  retval = SH_ALLOC(6 * sl_strlen(name) + 2);
 #else
-  if (sl_ok_muls (4, len) && sl_ok_adds ((4*len), 2))
-    { retval = SH_ALLOC(4 * len + 2); }
-  else
-    {
-      /* return an allocated array
-       */
-      retval = SH_ALLOC(11);
-      (void) sl_strlcpy(retval, _("(overflow)"), 11);
-      SL_RETURN(retval, _("sh_util_safe_name"));
-    }
+  retval = SH_ALLOC(4 * sl_strlen(name) + 2);
 #endif 
 
   (void) sl_strncpy(format, _("%c%03o"), 16);
+
+  p = name;
 
   while (*p != '\0') {
@@ -2094,11 +1484,6 @@
 #endif
     } else if ( (*p) == ' ') {     /* space            */
-      if (escape_space) {
-	retval[i] = '\\'; ++i; 
-	retval[i] = ' ';
-      }
-      else {
-	retval[i] = *p;
-      }
+      retval[i] = '\\'; ++i; 
+      retval[i] = ' ';
 #ifdef SH_USE_XML
     } else if ( (*p) == '"') {     /* double quote     */
@@ -2132,5 +1517,4 @@
     } else if (!isgraph ((int) *p)) {    /* not printable    */
       /*@-bufferoverflowhigh -formatconst@*/
-      /* flawfinder: ignore */
       sprintf(oct, format, '\\',                 /* known to fit  */
 	      (unsigned char) *p);
@@ -2150,7 +1534,7 @@
 }
 
-int sh_util_isnum (const char *str)
-{
-  const char *p = str;
+int sh_util_isnum (char *str)
+{
+  char *p = str;
 
   SL_ENTER(_("sh_util_isnum"));
@@ -2168,5 +1552,5 @@
 char * sh_util_strconcat (const char * arg1, ...)
 {
-  size_t    length, l2;
+  size_t    length;
   char    * s;
   char    * strnew;
@@ -2183,19 +1567,10 @@
   while (s != NULL)
     {
-      l2 = sl_strlen (s);
-      if (sl_ok_adds(length, l2))
-	length += l2;
-      else
-	SL_RETURN(NULL, _("sh_util_strconcat"));
+      length = length + sl_strlen (s);
       s = va_arg (vl, char * );
     }
   va_end (vl);
 
-  if (sl_ok_adds(length, 2))
-    strnew = SH_ALLOC( length + 2 );
-  else
-    SL_RETURN(NULL, _("sh_util_strconcat"));
-
-  /* cppcheck-suppress uninitvar */
+  strnew = SH_ALLOC( length + 2 ); 
   strnew[0] = '\0';
 
@@ -2212,172 +1587,4 @@
 
   SL_RETURN(strnew, _("sh_util_strconcat"));
-}
-
-static const char bto64_0[] = N_("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789()");
-static char bto64[65] = { '\0' };
-
-  
-size_t sh_util_base64_enc (unsigned char * out, 
-			   const unsigned char * instr, 
-			   size_t lin)
-{
-  int             ll;
-  unsigned char   a, b, c;
-  size_t          len  = 0;
-  size_t          j    = 0;
-
- start:
-  if (bto64[0] != '\0')
-    {
-      if (instr /* && *instr *//* need to handle binary data */)
-	{
-	  if (lin == 0)
-	    lin = strlen((const char *)instr);
-
-	  if (lin > 0)
-	    {
-	      do {
-		ll = 0;
-		
-		if (len < lin) 
-		  { a = *instr; ++instr; ++len; ++ll; }
-		else 
-		  { a = 0; }
-		if (len < lin) 
-		  { b = *instr; ++instr; ++len; ++ll; }
-		else 
-		  { b = 0; }
-		if (len < lin) 
-		  { c = *instr; ++instr; ++len; ++ll; }
-		else 
-		  { c = 0; }
-		
-		*out = bto64[ a >> 2 ];
-		++j; ++out;
-		*out = bto64[ ((a & 0x03) << 4) | ((b & 0xf0) >> 4) ];
-		++j; ++out;
-		*out = (unsigned char) (ll > 1 ? bto64[ ((b & 0x0f) << 2) | ((c & 0xc0) >> 6) ] : '?');
-		++j; ++out;
-		*out = (unsigned char) (ll > 2 ? bto64[ c & 0x3f ] : '?');
-		++j; ++out;
-	      } while (len < lin);
-	    }
-	}
-      *out = '\0';
-      return j;
-    }
-
-  memcpy(bto64, _(bto64_0), 65);
-  goto start;
-}
-
-size_t sh_util_base64_enc_alloc (char **out, const char *in, size_t inlen)
-{
-  size_t outlen = SH_B64_SIZ(inlen);
-
-  if (inlen > outlen) /* overflow */
-    {
-      *out = NULL;
-      return 0;
-    }
-
-  *out = SH_ALLOC(outlen);
-  return sh_util_base64_enc((unsigned char *)*out, (const unsigned char *)in, inlen);
-}
-
-size_t sh_util_base64_dec (unsigned char *out, 
-			   const unsigned char *in, 
-			   size_t lin)
-{
-  size_t i;
-  unsigned char c;
-  unsigned char b;
-  size_t lout = 0;
-  unsigned int  w = 0;
-
-  if (out && in)
-    {
-      if (lin == 0)
-	lin = strlen((const char *)in);
-
-      for (i = 0; i < lin; i++)
-	{
-	  c = *in; ++in;
-	  b = 0;
-	  
-	  if ((c >= 'A') && (c <= 'Z'))
-	    {
-	      b = (c - 'A');
-	    }
-	  else if ((c >= 'a') && (c <= 'z'))
-	    {
-	      b = (c - 'a' + 26);
-	    }
-	  else if ((c >= '0') && (c <= '9'))
-	    {
-	      b = (c - '0' + 52);
-	    }
-	  else if (c == '(' || c == '+')
-	    {
-	      b = 62;
-	    }
-	  else if (c == ')' || c == '/')
-	    {
-	      b = 63;
-	    }
-	  else if (c == '?' || c == '=')
-	    {
-	      /* last byte was written to, but will now get
-	       * truncated
-	       */
-	      if (lout > 0) --lout;
-	      break;
-	    }
-	  
-	  if (w == 0)
-	    {
-	      *out = (b << 2) & 0xfc;
-	      ++lout;
-	    }
-	  else if (w == 1)
-	    {
-	      *out |= (b >> 4) & 0x03;
-	      ++out;
-	      *out = (b << 4) & 0xf0;
-	      ++lout;
-	    }
-	  else if (w == 2)
-	    {
-	      *out |= (b >> 2) & 0x0f;
-	      ++out;
-	      *out = (b << 6) & 0xc0;
-	      ++lout;
-	    }
-	  else if (w == 3)
-	    {
-	      *out |= b & 0x3f;
-	      ++out;
-	    }
-	  
-	  ++w;
-	  
-	  if (w == 4)
-	    {
-	      w = 0;
-	    }
-	}
-      *out = '\0';
-    }
-  return lout;
-}
-
-size_t sh_util_base64_dec_alloc (unsigned char **out, const unsigned char *in, 
-				 size_t lin)
-{
-  size_t lout = 3 * (lin / 4) + 2;
-
-  *out = SH_ALLOC(lout);
-
-  return sh_util_base64_dec (*out, in, lin);
 }
 
@@ -2412,7 +1619,7 @@
   if (status != 0 && status != REG_NOMATCH) 
     {
-      errbuf = SH_ALLOC(BUFSIZ);
+      errbuf = SH_ALLOC(BUFSIZ+2);
       (void) regerror(status, &preg, errbuf, BUFSIZ); 
-      errbuf[BUFSIZ-1] = '\0';
+      errbuf[BUFSIZ] = '\0';
       sh_error_handle ((-1), FIL__, __LINE__, status, MSG_E_REGEX,
 		       errbuf, regex_str);
